//+------------------------------------------------------------------+
//|                                                    DeltaMA_2.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_plots   1
#property  indicator_color1  clrRed
#property  indicator_color2  clrBlue

extern bool alerts = true;     //   
extern int fMA = 1; // 2
extern int sMA = 2; // 5
extern int shift1 = 0;


double DeltaBuff1[];
double DeltaBuff2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping

   SetIndexBuffer(0,DeltaBuff1);
   SetIndexBuffer(1,DeltaBuff2);
   IndicatorShortName("DeltaMA_Signal");
   SetIndexLabel(0,"Sell ");
   SetIndexLabel(1,"Buy ");
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,2,indicator_color1);
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,2,indicator_color2);
   SetIndexArrow(0,222);
   SetIndexArrow(1,221);
   ArraySetAsSeries(DeltaBuff1,true);
   ArraySetAsSeries(DeltaBuff2,true);
   
//---
   return(INIT_SUCCEEDED);
  }

int deinit()
  {
   del("Strelka");
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int i,limit;
   static datetime nt = 0;
//---
   if(rates_total<=1)
      return(0);
//--- last counted bar will be recounted
   limit=rates_total-prev_calculated;
   //if(prev_calculated>0)
      //limit++;
      
   //if(limit<20){ limit = 20; }else{ limit=limit; }
   
   //limit = 10;
  //if (Time[0]==nt){ return 0; }
  //nt=Time[0];
   //Print("limit="+limit+"     prev_calculated="+prev_calculated+"    rates_total="+rates_total);
   //ArrayResize(DeltaBuff1,limit+1); ArrayResize(DeltaBuff2,limit+1);
   for(i=0; i<limit; i++){
      DeltaBuff1[i] = -1; DeltaBuff2[i] = -1;
      int shift60 = iBarShift(Symbol(),60,iTime(Symbol(),0,i));
      int shift240 = iBarShift(Symbol(),240,iTime(Symbol(),0,i));
      int shift1440 = iBarShift(Symbol(),1440,iTime(Symbol(),0,i));
      int shiftWeek = iBarShift(Symbol(),PERIOD_W1,iTime(Symbol(),0,i));
      
      string Naprav0 = MATrend(0,Symbol(),i);
      string Naprav60 = MATrend(60,Symbol(),shift60);
      string Naprav240 = MATrend(240,Symbol(),shift240);
      string Naprav1440 = MATrend(1440,Symbol(),shift1440);
      string NapravWeek = MATrend(PERIOD_W1,Symbol(),shiftWeek);
      
      if(Naprav0!=Naprav60 || Naprav0!=Naprav240 || Naprav0!=Naprav1440 || Naprav0!=NapravWeek){
         continue;
      }else{
         if(Naprav0=="Buy"){ DeltaBuff2[i] = iClose(Symbol(),0,i); }
         if(Naprav0=="Sell"){ DeltaBuff1[i] = iClose(Symbol(),0,i); }
      }
   }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+

string MATrend(int TF, string Valls, int sdvigbb)
 {
  int fastema = fMA;          //   
  int slowema = sMA;         //   
  //if(slowema==fastema){ slowema=5; }
  string t=""; // MODE_EMA
  double maFast=iMA(Valls,TF,fastema,0,MODE_LWMA,PRICE_CLOSE,sdvigbb+shift1);
  double maSlow=iMA(Valls,TF,slowema,0,MODE_LWMA,PRICE_CLOSE,sdvigbb+shift1);

  double maFast1=iMA(Valls,TF,fastema,0,MODE_LWMA,PRICE_CLOSE,sdvigbb+shift1+1);
  double maSlow1=iMA(Valls,TF,slowema,0,MODE_LWMA,PRICE_CLOSE,sdvigbb+shift1+1);

  if((maFast-maSlow)>(maFast1-maSlow1)) t="Buy";
  if((maFast-maSlow)<(maFast1-maSlow1)) t="Sell";
/*
  if((maFast-maSlow)>MarketInfo(Valls, MODE_POINT)) t="Buy";
  if((maFast-maSlow)<-(MarketInfo(Valls, MODE_POINT))) t="Sell";
  */
  return(t);
}

//----------------------------------------------------
void StrelkaVverh(string Val, datetime TimeA, double PriceA, color ColorA){
    ObjectCreate("Strelka_"+Val+TimeA, OBJ_ARROW, 0, TimeA, PriceA);
    ObjectSet("Strelka_"+Val+TimeA, OBJPROP_COLOR, ColorA);
    ObjectSet("Strelka_"+Val+TimeA, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
}
void StrelkaVniz(string Val, datetime TimeA, double PriceA,color ColorA){
    ObjectCreate("Strelka_"+Val+TimeA, OBJ_ARROW, 0, TimeA, PriceA);
    ObjectSet("Strelka_"+Val+TimeA, OBJPROP_COLOR, ColorA); 
    ObjectSet("Strelka_"+Val+TimeA, OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN); 
}
int del(string name)                                    // . - deinit()
{
   for(int n=ObjectsTotal()-1; n>=0; n--) 
     {
      string Obj_Name=ObjectName(n);
      if (StringFind(Obj_Name,name,0) != -1)
      {
         ObjectDelete(Obj_Name);
      }
   }
   return 0;                                      //   deinit()
}